class Station:
 def __init__(self, name, sttype, extid = None, xcoord = None, ycoord = None, prodclass = None):
  self.name = name
  self.sttype = sttype
  self.extid = extid
  self.xcoord = float(xcoord)/1000000
  self.ycoord = float(ycoord)/1000000
  self.prodclass = prodclass

 def useId(self):
  return self.extid or self.name

 def lat(self):
  return self.ycoord

 def lon(self):
  return self.xcoord

 def json(self, indent = 0, name = True, extid = True, sttype = False, coords = False, prodclass = False, distance = False):
  out = " " * indent + "{\n"

  out += (" " * indent + " \"name\": \"%s\",\n" % self.name) if name else ""
  out += (" " * indent + " \"id\": \"%s\",\n" % self.useId()) if extid else ""
  out += (" " * indent + " \"distance\": %i,\n" % int(self.distance)) if distance else ""
  out += (" " * indent + " \"type\": \"%s\",\n" % self.sttype) if sttype else ""

  if coords:
   out += " " * indent + " \"coords\": {\n"
   out += " " * indent + "  \"lon\": %f,\n" % self.xcoord
   out += " " * indent + "  \"lat\": %f\n" % self.ycoord
   out += " " * indent + " },\n"

  out += (" " * indent + " \"prodclass\": \"%s\",\n" % self.prodclass) if prodclass else ""

  out = "".join(out.rsplit(",", 1))

  out += " " * indent + "}"

  return out

 def xml(self, indent = 0, name = True, extid = True, sttype = False, coords = False, prodclass = False, distance = False):
  out = " " * indent + "<station>\n"

  out += (" " * indent + " <name>%s</name>\n" % self.name) if name else ""
  out += (" " * indent + " <id>%s</id>\n" % self.useId()) if extid else ""
  out += (" " * indent + " <distance>%i</distance>\n" % int(self.distance)) if distance else ""
  out += (" " * indent + " <type>%s</type>\n" % self.sttype) if sttype else ""

  if coords:
   out += " " * indent + " <coords>\n"
   out += " " * indent + "  <lon>%f</lon>\n" % self.xcoord
   out += " " * indent + "  <lat>%f</lat>\n" % self.ycoord
   out += " " * indent + " </coords>\n"

  out += (" " * indent + " <prodclass>%s</prodclass>\n" % self.prodclass) if prodclass else ""

  out += " " * indent + "</station>"

  return out

